%global major                           1

Name:                                   LTK
Version:                                1.9.5
Release:                                35%{?dist}
Summary:                                Ladspa v3 ToolKit

License:                                GPLv3
URL:                                    https://copr.fedorainfracloud.org/coprs/lewisanesa/CodeColla/

# git clone git://codecolla.com/libltk
# cd 0000000000000000_ltk/PROJECT
# git archive --format tar.gz --prefix LTK-1.9.5/ v1.9.5 > LTK-1.9.5.tar.gz
# . make.sh
Source0:                                SOURCES/%{name}-%{version}.tar.gz

BuildRequires:                          gcc
BuildRequires:                          glibc-devel
BuildRequires:                          make
BuildRequires:                          libunwind-devel

Requires:                               libunwind

%description
Ladspa V3 ToolKit is a general purpose toolkit
enabling object oriented programming in c.

%package                                devel
Summary:                                Development files for %{name}
Requires:                               %{name}%{?_isa} = %{version}-%{release}

%description                            devel
The %{name}-devel package contains libraries and header files
for developing applications that use %{name}.

%prep
%autosetup

%build
%set_build_flags
%make_build NAME=%{name} VERSION=%{version} MAJOR=%{major}

%install
install -pm 0755 -D bin/lib%{name}.so.%{major} %{buildroot}%{_libdir}/lib%{name}.so.%{major}
ln -s %{_libdir}/lib%{name}.so.%{major} %{buildroot}%{_libdir}/lib%{name}.so.%{version}
ln -s %{_libdir}/lib%{name}.so.%{major} %{buildroot}%{_libdir}/lib%{name}.so
mkdir -p %{buildroot}%{_includedir}/%{name}
install -pm 0644 -D include/* %{buildroot}%{_includedir}/%{name}/
mkdir -p %{buildroot}%{_mandir}/man3
install -pm 0644 -D  man/*.3 %{buildroot}%{_mandir}/man3/

%files
%license LICENSE
%{_libdir}/lib%{name}.so.%{major}*

%files devel
%{_libdir}/lib%{name}.so
%{_includedir}/%{name}
%{_mandir}/man3/LTK.3.*
%{_mandir}/man3/LTKAdd.3.*
%{_mandir}/man3/LTKAddClass.3.*
%{_mandir}/man3/LTKArray.3.*
%{_mandir}/man3/LTKBacktrace.3.*
%{_mandir}/man3/LTKConfigure.3.*
%{_mandir}/man3/LTKExec.3.*
%{_mandir}/man3/LTKGetObjectID.3.*
%{_mandir}/man3/LTKHash.3.*
%{_mandir}/man3/LTKLog.3.*
%{_mandir}/man3/LTKRand.3.*
%{_mandir}/man3/LTKRun.3.*
%{_mandir}/man3/LTKTrg.3.*

%changelog
* Sat Jul 13 2024 Lewis ANESA <lan@codecolla.com>
- Merge branch 'Real_time' into dev

* Sat Jul 13 2024 Lewis ANESA <lan@codecolla.com>
- Removed ltk_callback_free_behaviour logic from ltk_stream and all it's derivate
- Substitued LTKCFG_FREE_LAST_POOL_IF_EMPTY for LTKCFG_IS_GLOBAL_FREE_RUNNING which is now useless
- Added LTK prefix to ltk_timer_mode enum

* Wed Jul 03 2024 Lewis ANESA <lan@codecolla.com>
- Merge branch 'Freeing_and_copy_utility' into dev

* Wed Jul 03 2024 Lewis ANESA <lan@codecolla.com>
- Separated instance freeing handler
- Added class freeing handler
- Added LTKmemcpy function to gather memcpy and memmove in the same place

* Sun Jul 31 2022 Lewis ANESA <lan@codecolla.com>
- Merge branch 'build_pretty' into dev

* Sun Jul 31 2022 Lewis ANESA <lan@codecolla.com>
- Added colored names on builds at Makefile level
- Pretty a part of include files

* Sun Jul 03 2022 Lewis ANESA <lan@codecolla.com>
- Merge branch 'Man_pages' into dev

* Sun Jul 03 2022 Lewis ANESA <lan@codecolla.com>
- Added man page file attachement to the package with spec file

* Thu May 19 2022 Lewis ANESA <lan@codecolla.com>
- Merge branch 'Memory_corruption' into dev

* Thu May 19 2022 Lewis ANESA <lan@codecolla.com>
- Resolved segfault on free all memory while none already allowed

* Thu May 19 2022 Lewis ANESA <lan@codecolla.com>
- Merge branch 'dev' into Memory_corruption

* Fri May 13 2022 Lewis ANESA <lan@codecolla.com>
- Merge branch 'For_each' into dev

* Fri May 13 2022 Lewis ANESA <lan@codecolla.com>
- Reverted GNU format on instance
- Added freeing control on "for each" functions avoiding read of freeded memory

* Fri May 13 2022 Lewis ANESA <lan@codecolla.com>
- Merge branch 'dev' into For_each

* Tue May 03 2022 Lewis ANESA <lan@codecolla.com>
- Merge branch 'Execution_export' into dev

* Tue May 03 2022 Lewis ANESA <lan@codecolla.com>
- Exported execution to a subprocess extension

* Tue May 03 2022 Lewis ANESA <lan@codecolla.com>
- Merge branch 'Get_class' into dev

* Tue May 03 2022 Lewis ANESA <lan@codecolla.com>
- Added LTKGetClass fuction to get class from an instance

* Tue Apr 19 2022 Lewis ANESA <lan@codecolla.com>
- Merge branch 'Members_management' into dev

* Tue Apr 19 2022 Lewis ANESA <lan@codecolla.com>
- Changed LTKMember to treat class rather than instance

* Tue Apr 19 2022 Lewis ANESA <lan@codecolla.com>
- Merge branch 'Members_management' into dev

* Tue Apr 19 2022 Lewis ANESA <lan@codecolla.com>
- Added LTKMember and missing LTKvRun functions

* Wed Apr 13 2022 Lewis ANESA <lan@codecolla.com>
- Merge branch 'Dependency_management' into dev

* Wed Apr 13 2022 Lewis ANESA <lan@codecolla.com>
- Integrated dependency chain

* Wed Apr 13 2022 Lewis ANESA <lan@codecolla.com>
- Merge branch 'Subprocess_execution' into dev

* Wed Apr 13 2022 Lewis ANESA <lan@codecolla.com>
- Added missing invokation to socket for utils fd transfert functions

* Wed Apr 13 2022 Lewis ANESA <lan@codecolla.com>
- Merge branch 'dev' into Subprocess_execution

* Tue Apr 12 2022 Lewis ANESA <lan@codecolla.com>
- Merge commit 'Subprocess_execution' into dev

* Tue Apr 12 2022 Lewis ANESA <lan@codecolla.com>
- Modified LTKExec declaration in header file to fit code
- Added fd transfers with subprocess facilities

* Tue Apr 12 2022 Lewis ANESA <lan@codecolla.com>
- Modified LTKExec to permit fd transfers with subprocess

* Tue Apr 12 2022 Lewis ANESA <lan@codecolla.com>
- Merge branch 'dev' into Subprocess_execution

* Mon Apr 11 2022 Lewis ANESA <lan@codecolla.com>
- Merge branch 'For_each' into dev

* Mon Apr 11 2022 Lewis ANESA <lan@codecolla.com>
- Spreadded "For Each" functions over use cases
- Resolved no logs bug
- Extended copyright

* Sun Apr 03 2022 Lewis ANESA <lan@codecolla.com>
- Merge branch 'Memory_corruption' into dev

* Sun Apr 03 2022 Lewis ANESA <lan@codecolla.com>
- Added a global freeing flag, write protected
- Corrected read/write config flags mechanisms

* Wed Mar 23 2022 Lewis ANESA <lan@codecolla.com>
- Merge branch 'Subprocess_execution' into dev

* Wed Mar 23 2022 Lewis ANESA <lan@codecolla.com>
- Included unistd for pid_t usage

* Mon Oct 04 2021 Lewis ANESA <lan@codecolla.com>
- Merge branch 'GNU_Conforming' into dev

* Mon Oct 04 2021 Lewis ANESA <lan@codecolla.com>
- Renamed man files to fit function renamings
- Reindented sources to fit GNU standards using cli0

* Sun Oct 03 2021 Lewis ANESA <lan@codecolla.com>
- Clarified function names
- Removed sync functions in favor to an dedicated extension

* Sat Oct 02 2021 Lewis ANESA <lan@codecolla.com>
- Clarified shared types

* Sat Oct 02 2021 Lewis ANESA <lan@codecolla.com>
- Added copyright notices and licence reminder in all files

* Wed May 26 2021 Lewis ANESA <lan@codecolla.com>
- Made sure make script treats all possible man pages

* Thu May 20 2021 lan <lan@codecolla.com>
- Removed unused inclusions in utils header
- Made sure that LTKFehClass isn't exported
- Added support to the no release case in make script

* Fri Oct 30 2020 Lewis ANESA <lan@codecolla.com>
- Merge branch 'Bug_1853888'
* Tue Sep 29 2020 Lewis ANESA <lan@codecolla.com>
- Merge branch 'logs'
* Tue Sep 29 2020 Lewis ANESA <lan@codecolla.com>
- Corrected LTKArray inverted error logic

* Tue Sep 29 2020 Lewis ANESA <lan@codecolla.com>
- Merge branch 'dev'
* Wed Jul 15 2020 Lewis ANESA <lan@codecolla.com>
- Corrected links and compil flags

* Wed Jul 15 2020 Lewis ANESA <lan@codecolla.com>
- Merge branch 'Bug_1853888'
* Wed Jul 15 2020 Lewis ANESA <lan@codecolla.com>
- Added a MAJOR global definition in the specfile
- Commented and corrected Source0
- Added empty line management in dependencies
- Switched %prep to %autosetup
- Added intermediate shared object file with only major in name
- Added it to soname on gcc final output
- Gathered together install files and managed multi section manpages
- Added link layer to proper tarball creation
- Added fedora's compil flags
- Removed libunwind dependency (libunwind-devel build dep is enough)
- Added constant strings to sprintf calls (fedora flags compatibility)

* Thu Jul 09 2020 Lewis ANESA <lan@codecolla.com>
- Merge branch 'Bug_1853888'
* Thu Jul 09 2020 Lewis ANESA <lan@codecolla.com>
- Added download and build instructions in spec file
- Changed Source to Source0 and point to the right location
- Leaved make flag management to rpm mechanisms
- Moved the so link in devel files section
- Substituted cp for gzip
- Prevented mkdir copy

* Mon Jul 06 2020 Lewis ANESA <lan@codecolla.com>
- Merge branch 'Bug_1853888'
* Mon Jul 06 2020 Lewis ANESA <lan@codecolla.com>
- Added version to temporary file's name

* Mon Jul 06 2020 Lewis ANESA <lan@codecolla.com>
- Added line feeds to spec file
- Added a devel section for include and man pages to spec file
- Added version and release number to spec file name
- Removed %postun section from spec file
- Moved pictures from PROJECT to DOCUMENTATION

* Sat Jul 04 2020 Lewis ANESA <lan@codecolla.com>
- Merge branch 'logs'
* Sat Jul 04 2020 Lewis ANESA <lan@codecolla.com>
- Corrected LTKFre erroneous message

* Sat Jul 04 2020 Lewis ANESA <lan@codecolla.com>
- Merge branch 'rpm'
* Sat Jul 04 2020 Lewis ANESA <lan@codecolla.com>
- Merge branch 'logs'
* Sat Jul 04 2020 Lewis ANESA <lan@codecolla.com>
- Corrected mistakes blocking compilation

* Sat Jul 04 2020 Lewis ANESA <lan@codecolla.com>
- Added info and warning logs to instance functions.
- Reorganised header inclusions.

* Sun Jun 28 2020 Lewis ANESA <lan@codecolla.com>
- Added error logs to instance functions.
- Updated an LTKOid error code to meet it's manpage content.

* Sun Jun 28 2020 Lewis ANESA <lan@codecolla.com>
- Removed exceeding value to LTKRoot definition.
- Added logs to utils functions

* Sun Jun 28 2020 Lewis ANESA <lan@codecolla.com>
- Switched from __FUNCTION__ to __func__ to meet gnu standards.
- Removed -Wno-undef that was used for debug reasons.
- Switched to absolute path on symblinks making
- to meet rpm build standards.
- Note that -sf argument is not required
- since buildroot is empty at rpm build time, -s is enough.
- In tests made, -sf makes resulting package uncompatible with dnf.

* Sat Jun 20 2020 Lewis ANESA <lan@codecolla.com>
- Merge branch 'logs'
* Sat Jun 20 2020 Lewis ANESA <lan@codecolla.com>
- Merge branch 'todos'
* Sat Jun 20 2020 Lewis ANESA <lan@codecolla.com>
- Correcter man pages titles

* Sat Jun 20 2020 Lewis ANESA <lan@codecolla.com>
- Merge branch 'dev'
* Sat Jun 20 2020 Lewis ANESA <lan@codecolla.com>
- Added LTKBacktrace as a dedicated function
- Simplified LTKLog function

* Thu Jun 04 2020 Lewis ANESA <lan@codecolla.com>
- Added simple __FUNCTION__ support

* Sat May 30 2020 Lewis ANESA <lan@codecolla.com>
- Resolved flag issue in LTKCtl impacting log mechanisms
- Added LTKLog function with macro helper

* Fri May 29 2020 Lewis ANESA <lan@codecolla.com>
- Merge branch 'versionning'
* Fri May 29 2020 Lewis ANESA <lan@codecolla.com>
- Fixed missed double quote, patch was not incrementing

* Thu May 28 2020 Lewis ANESA <lan@codecolla.com>
- Merge branch 'todos'
* Thu May 28 2020 Lewis ANESA <lan@codecolla.com>
- Inspected LTKOid, nothing to do, verified.

* Mon May 25 2020 Lewis ANESA <lan@codecolla.com>
- Substitued dichotomy for bit shift in free slot search engine
- Execution speed is now twice faster as before

* Fri May 22 2020 Lewis ANESA <lan@codecolla.com>
- Merge branch 'versionning'
* Fri May 22 2020 Lewis ANESA <lan@codecolla.com>
- Managed multiline hash
- Managed first master commit

* Fri May 22 2020 Lewis ANESA <lan@codecolla.com>
- Merge branch 'versionning'
* Fri May 22 2020 Lewis ANESA <lan@codecolla.com>
- Automated versionning
- Removed versionning check in server's pre-receive hook
- Now versionning is based on git logs

* Thu May 21 2020 Lewis ANESA <lan@codecolla.com>
- Merge branch 'import'
* Thu May 21 2020 Lewis ANESA <lan@codecolla.com>
- Updated version

* Thu May 21 2020 Lewis ANESA <lan@codecolla.com>
- Corrected LTKArray man page
- Added LTKExec man page
- Added no pipe creation if no provided fd in LTKExec

* Thu May 21 2020 Lewis ANESA <lan@codecolla.com>
- Merge branch 'dev'
* Thu May 21 2020 Lewis ANESA <lan@codecolla.com>
- Added LTKRand, LTKHash and LTKAray manpages
- Secured LTKArray

* Sun May 17 2020 Lewis ANESA <lan@codecolla.com>
- Added Hash function to utils.h
- Now LTKHash() available with featured LTK_HASH macro

* Sun May 17 2020 Lewis ANESA <lan@codecolla.com>
- Merge branch 'import'
* Sun May 17 2020 Lewis ANESA <lan@codecolla.com>
- Updating version

* Fri May 15 2020 Lewis ANESA <lan@codecolla.com>
- Changed last part of man dirpath
- to stick on fedora's file organization

* Fri May 15 2020 Lewis ANESA <lan@codecolla.com>
- Update Adapted doc to the provided one

* Thu May 14 2020 Lewis ANESA <lan@codecolla.com>
- First import from existing project

* Thu May 14 2020 libltk <libltk@codecolla.com>
- dev init

* Thu May 14 2020 libltk <libltk@codecolla.com>
- master init

